Program Feladatsor_415_varians;
(*
  Feladat:
    Adott egy kr N pontja. Sorba kell lltani az ramutat
    jrsnak megfelelen.
  Megoldas:
  0. Tetelek
     = Rendezs (polrkoordinta szerint)
  1. Specifikacio:
     Be: N:Egesz, Pont:(X x Y)^*, X,Y=Valos
     Ki: Pont':(X x Y)^*
     Ef: -
     Uf: Pont' ELEME Permutci(Pont)  ES
         Rendezett[Polar](Pont')
     Def: Rendezett[Polar]:(X x Y)^*  --> Logikai
          Rendezett[Polar](p):=Rendezett(PolarSzog(p.X,p.Y))
          Polarszog: X x Y --> Valos
          PolarSzog(p):=... p.X,p.Y "latoszoge" origobol ...
!!!
  Megjegyzes:
    A program utn az adatgenertor progrgam...
*)
  Uses  Crt22;
  Const MaxN=250;
  Type  TPont=Record
                x,y:real;
              End;
        TPontok=Array [1..MaxN] of TPont;
  Var   N:Integer;
        korPont:TPontok;

  Procedure Listazas(cim:String; t:TPontok; db:Integer);
    Var i,j:Integer;
  Begin
    UjLap(cim,0{nem vr});
    For i:=1 to db do
    Begin
      Write(' (',t[i].x:6:2,',',t[i].y:6:2,')    ');
    End;{For i}
  End;

  Procedure AdatBeolvasas;
    Var i,j:Integer;
        be:String;
  Begin
    (*
      Beolvass a specifiklt inputrl [l. a Crt22 unit lerst!]:
      Figyelem:
        ha a file-input hibs, akkor "vgtelen ciklusba" eshet...
    *)
    UjLap('Krpontok',0{nem vr});
    Repeat
      Write('Pontok szma:');
      Readln(N);
    Until N in [1..MaxN];
    For i:=1 to N do
    Begin
      Writeln(i:2,'. pont x- s y-koordintja ',
                  ' (soronknt pontpr):');
      Write(' x,y:');
      Readln(korPont[i].x,korPont[i].y); {ellenrizend: egy kr pontjai-e}
    End;

    {Ellenrz kirs a kpernyre:}
    KonzolOutput;
    Listazas('Az eredeti pontok',korPont,N);
    BillreVar;
    {Visszavlts az esetleges file-outputra:}
    FileOutput('');
  End;

  Function FoSzog(x,y:Real):Real;
   {Ef: az 1. sknegyedbe esik az (x,y) pont}
  Begin
    FoSzog:=ArcTan(y/x)
  End;

  Function Szog(x,y:Real):Real;
  Begin
    If
      y>0 then {1. s 2. sknegyed:}
        Begin
          If
            x>0 then {1.}
              Begin
                Szog:=FoSzog(x,y);
              End else if
            x=0 then {origo}
              Begin
                Szog:=0;
              End
            Else  {x<0: 2.}
              Begin
                Szog:=Pi-FoSzog(Abs(x),y); {Pi/2+(Pi/2-FoSzog(x,y))}
              End
          {EndIf};
        End Else if
      y=0 then {x tengely:}
        Begin
          If x>0 then {0 radian}
              Begin
                Szog:=0;
              End
          Else  {Pi radian}
              Begin
                Szog:=Pi;
              End
          {EndIf};
        End
      Else {y<0: 3. s 4. sknegyed:}
        Begin
          If
            x>0 then {4.}
              Begin
                Szog:=2*Pi-FoSzog(x,Abs(y)); {3*Pi/2+(Pi/2-FoSzog(x,y))}
              End else if
            x=0 then {origo}
              Begin
                Szog:=0;
              End
            Else  {x<0: 3.}
              Begin
                Szog:=Pi+FoSzog(Abs(x),Abs(y));
              End
          {EndIf};
        End
    {EndIf};
  End;

  Procedure EredmenyKiiras;
    Var i:Integer;
  Begin
    (*
      Kirs a specifiklt outputra.
      Azaz ha van outputfile specifiklva, akkor ttrs arra;
      klnben marad a konzoloutput.
    *)
    UjLap('A rendezett pontsor',0{billre vr});
    For i:=1 to N do
    Begin
      Writeln(i:3,'.:(',korPont[i].x:6:2,',',korPont[i].x:6:2,')=[',
                  Szog(korPont[i].x,korPont[i].y):6:2,']');
    End;
    BillreVar;
  End;

  Procedure Rendezes(Var p:TPontok; db:Integer);
    Var i,j:Integer;
        pp:TPont;
  Begin
    For i:=2 to db do
    Begin
      j:=i-1; pp:=p[i];
      While (j>0) and (Szog(p[j].x,p[j].y)>Szog(pp.x,pp.y)) do
      Begin
        p[j+1]:=p[j];
        Dec(j)
      End;
      p[j+1]:=pp
    End;
  End;

Begin
  {Adatbeolvass file-bl v. konzolrl:}
  AdatBeolvasas;
  {Feldolgozs:}
  Rendezes(korPont,N);
  {Kirs file-ba v. konzolra:}
  EredmenyKiiras;
End.


Az adatfile generlsa lehetsges az albbival:

Uses crt22;
Var i,n:Integer;
    r,fi,x,y:Real;
Begin
  {"Kzi paramterbellts:}
  n:=99; r:=1; FileOutput('KorPon99.dat');

  Writeln(n);
  For i:=1 to n do
  Begin
    fi:=Random*2*Pi; x:=r*Cos(fi); y:=r*Sin(fi);
    Writeln(x:6:2,y:6:2,' {',fi:4:2,' rad.}');
  End;

End.